package com.ximai.mes.pro.service.productionRequest;

import java.util.List;
import com.ximai.mes.pro.domain.productionRequest.ProProductionRequestProcessQcindex;
import com.ximai.mes.pro.domain.vo.ProProductionRequestProcessQcindexVo;

/**
 * 量产申请工序检验项Service接口
 *
 * @author generator
 * @date 2024-01-27
 */
public interface IProProductionRequestProcessQcindexService
{
    /**
     * 查询量产申请工序检验项
     *
     * @param productionRequestProcessQcindexId 量产申请工序检验项主键
     * @return 量产申请工序检验项
     */
    public ProProductionRequestProcessQcindex selectProProductionRequestProcessQcindexByProductionRequestProcessQcindexId(Long productionRequestProcessQcindexId);

    /**
     * 查询量产申请工序检验项列表
     *
     * @param proProductionRequestProcessQcindex 量产申请工序检验项
     * @return 量产申请工序检验项集合
     */
    public List<ProProductionRequestProcessQcindex> selectProProductionRequestProcessQcindexList(ProProductionRequestProcessQcindex proProductionRequestProcessQcindex);

    public List<ProProductionRequestProcessQcindexVo> selectProProductionRequestProcessQcindexVoList(ProProductionRequestProcessQcindex proProductionRequestProcessQcindex);

    /**
     * 新增量产申请工序检验项
     *
     * @param proProductionRequestProcessQcindex 量产申请工序检验项
     * @return 结果
     */
    public int insertProProductionRequestProcessQcindex(ProProductionRequestProcessQcindex proProductionRequestProcessQcindex);

    /**
     * 修改量产申请工序检验项
     *
     * @param proProductionRequestProcessQcindex 量产申请工序检验项
     * @return 结果
     */
    public int updateProProductionRequestProcessQcindex(ProProductionRequestProcessQcindex proProductionRequestProcessQcindex);

    /**
     * 批量删除量产申请工序检验项
     *
     * @param productionRequestProcessQcindexIds 需要删除的量产申请工序检验项主键集合
     * @return 结果
     */
    public int deleteProProductionRequestProcessQcindexByProductionRequestProcessQcindexIds(Long[] productionRequestProcessQcindexIds);

    /**
     * 删除量产申请工序检验项信息
     *
     * @param productionRequestProcessQcindexId 量产申请工序检验项主键
     * @return 结果
     */
    public int deleteProProductionRequestProcessQcindexByProductionRequestProcessQcindexId(Long productionRequestProcessQcindexId);
}
